"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.renderHook = renderHook;
exports.testHook = testHook;
Object.defineProperty(exports, "cleanup", {
  enumerable: true,
  get: function get() {
    return _reactTestingLibrary.cleanup;
  }
});
Object.defineProperty(exports, "act", {
  enumerable: true,
  get: function get() {
    return _reactTestingLibrary.act;
  }
});

var _react = _interopRequireDefault(require("react"));

var _reactTestingLibrary = require("react-testing-library");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function TestHook(_ref) {
  var callback = _ref.callback,
      hookProps = _ref.hookProps,
      children = _ref.children;
  children(callback(hookProps));
  return null;
}

function renderHook(callback, _ref2) {
  if (_ref2 === void 0) {
    _ref2 = {};
  }

  var _ref3 = _ref2,
      initialProps = _ref3.initialProps,
      options = _objectWithoutPropertiesLoose(_ref3, ["initialProps"]);

  var result = {
    current: null
  };
  var hookProps = {
    current: initialProps
  };

  var toRender = function toRender() {
    return _react.default.createElement(TestHook, {
      callback: callback,
      hookProps: hookProps.current
    }, function (res) {
      result.current = res;
    });
  };

  var _render = (0, _reactTestingLibrary.render)(toRender(), options),
      unmount = _render.unmount,
      rerenderComponent = _render.rerender;

  return {
    result: result,
    unmount: unmount,
    rerender: function rerender(newProps) {
      if (newProps === void 0) {
        newProps = hookProps.current;
      }

      hookProps.current = newProps;
      rerenderComponent(toRender());
    }
  };
}

function testHook() {
  console.warn('`testHook` has been deprecated and will be removed in a future release.  Please use `renderHook` instead.');
  return renderHook.apply(void 0, arguments);
}